import DemoButton from './demo-button';
import UiDatePicker from './ui-date-picker';
import UiPicker from './ui-picker';
import UiTableView from './ui-table-view';
var version = '1.0.2';

function install(Vue) {
  var components = [DemoButton, UiDatePicker, UiPicker, UiTableView];
  components.forEach(function (item) {
    if (item.install) {
      Vue.use(item);
    } else if (item.name) {
      Vue.component(item.name, item);
    }
  });
}

if (typeof window !== 'undefined' && window.Vue) {
  install(window.Vue);
}

export { install, version, DemoButton, UiDatePicker, UiPicker, UiTableView };
export default {
  install: install,
  version: version
};