"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;
exports.install = install;
exports.version = void 0;

var _demoButton = _interopRequireDefault(require("./demo-button"));

exports.DemoButton = _demoButton.default;

var _uiDatePicker = _interopRequireDefault(require("./ui-date-picker"));

exports.UiDatePicker = _uiDatePicker.default;

var _uiPicker = _interopRequireDefault(require("./ui-picker"));

exports.UiPicker = _uiPicker.default;

var _uiTableView = _interopRequireDefault(require("./ui-table-view"));

exports.UiTableView = _uiTableView.default;
var version = '1.0.2';
exports.version = version;

function install(Vue) {
  var components = [_demoButton.default, _uiDatePicker.default, _uiPicker.default, _uiTableView.default];
  components.forEach(function (item) {
    if (item.install) {
      Vue.use(item);
    } else if (item.name) {
      Vue.component(item.name, item);
    }
  });
}

if (typeof window !== 'undefined' && window.Vue) {
  install(window.Vue);
}

var _default = {
  install: install,
  version: version
};
exports.default = _default;